using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;

namespace MultiColumnTree
{
	/// <summary>
	/// Test Form fr den MultiColumnTree. Der MCT hat 4 zentrale Eigenschaften:
	///		Bindings: Ein String Array, in der die Propertynamen fr die Spalten definiert werden.
	///		Captions: Ein String Array, in dem die Spaltenberschriften stehen.
	///		FileContextMenues: Ein ContextMenu Array, fr die Spalten der Dateien.
	///		FolderContextMenues: Ein ContextMenu Array, fr die Spalten der Verzeichnisse.
	///	Der MCT hat folgende Events:
	///		CheckedChanged: Der Haken wurde gendert.
	///		ColumnChanged: Eine Wert in der Spalte wurde verndert.
	///		Selected: Eine Wert wurde selektiert.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.MenuItem menuItem4;
		private System.Windows.Forms.MenuItem menuItem5;
		private System.Windows.Forms.MenuItem menuItem6;
		private System.Windows.Forms.MenuItem menuItem7;
		private System.Windows.Forms.MenuItem menuItem8;
		private System.Windows.Forms.MenuItem menuItem9;
		private System.Windows.Forms.ContextMenu contextMenu1;
		private System.Windows.Forms.ContextMenu contextMenu2;
        private MultiColumnTree.Tree tree1;
		private System.Windows.Forms.MenuItem menuItemEdit;
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.TextBox textBox2;
		private System.Windows.Forms.TextBox textBox3;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.ContextMenu contextMenu3;
		private System.Windows.Forms.ContextMenu contextMenu4;

		private TreeNode gn = new TreeNode();

		public Form1()
		{
			InitializeComponent();
			// the following attributes are lost when the MultiColumnTree has a compilation error
			this.tree1.Bindings = new string[] {
												   "Name",
												   "Create",
												   "Write",
												   "Access"};
			this.tree1.Captions = new string[] {
												   "Name",
												   "erstellt",
												   "gendert",
												   "verwendet"};
			this.tree1.FileContextMenues = new System.Windows.Forms.ContextMenu[] {
											this.contextMenu1, null, this.contextMenu1};
			this.tree1.FolderContextMenues = new System.Windows.Forms.ContextMenu[] {
											this.contextMenu2, null, this.contextMenu2};
//			this.tree1.WithCheckBoxes = true;
		}

		/// <summary>
		/// Die verwendeten Ressourcen bereinigen.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Vom Windows Form-Designer generierter Code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
            this.contextMenu1 = new System.Windows.Forms.ContextMenu();
            this.menuItem4 = new System.Windows.Forms.MenuItem();
            this.menuItem5 = new System.Windows.Forms.MenuItem();
            this.menuItem6 = new System.Windows.Forms.MenuItem();
            this.menuItemEdit = new System.Windows.Forms.MenuItem();
            this.contextMenu2 = new System.Windows.Forms.ContextMenu();
            this.menuItem7 = new System.Windows.Forms.MenuItem();
            this.menuItem8 = new System.Windows.Forms.MenuItem();
            this.menuItem9 = new System.Windows.Forms.MenuItem();
            this.tree1 = new MultiColumnTree.Tree();
            this.textBox1 = new System.Windows.Forms.TextBox();
            this.textBox2 = new System.Windows.Forms.TextBox();
            this.textBox3 = new System.Windows.Forms.TextBox();
            this.label1 = new System.Windows.Forms.Label();
            this.label2 = new System.Windows.Forms.Label();
            this.contextMenu3 = new System.Windows.Forms.ContextMenu();
            this.contextMenu4 = new System.Windows.Forms.ContextMenu();
            this.SuspendLayout();
            // 
            // contextMenu1
            // 
            this.contextMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.menuItem4,
            this.menuItem5,
            this.menuItem6,
            this.menuItemEdit});
            // 
            // menuItem4
            // 
            this.menuItem4.Index = 0;
            this.menuItem4.Text = "m1";
            // 
            // menuItem5
            // 
            this.menuItem5.Index = 1;
            this.menuItem5.Text = "m2";
            // 
            // menuItem6
            // 
            this.menuItem6.Index = 2;
            this.menuItem6.Text = "m3";
            // 
            // menuItemEdit
            // 
            this.menuItemEdit.Index = 3;
            this.menuItemEdit.Text = "Edit";
            this.menuItemEdit.Click += new System.EventHandler(this.menuItemEdit_Click);
            // 
            // contextMenu2
            // 
            this.contextMenu2.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.menuItem7,
            this.menuItem8,
            this.menuItem9});
            // 
            // menuItem7
            // 
            this.menuItem7.Index = 0;
            this.menuItem7.Text = "r1";
            // 
            // menuItem8
            // 
            this.menuItem8.Index = 1;
            this.menuItem8.Text = "r2";
            // 
            // menuItem9
            // 
            this.menuItem9.Index = 2;
            this.menuItem9.Text = "r3";
            // 
            // tree1
            // 
            this.tree1.BackColor = System.Drawing.SystemColors.Control;
            this.tree1.Bindings = new string[] {
        "Name",
        "Create",
        "Write",
        "Access"};
            this.tree1.Captions = new string[] {
        "Name",
        "erstellt",
        "gendert",
        "verwendet"};
            this.tree1.FileContextMenues = new System.Windows.Forms.ContextMenu[] {
        this.contextMenu1,
        null,
        this.contextMenu1};
            this.tree1.FolderContextMenues = new System.Windows.Forms.ContextMenu[] {
        this.contextMenu2,
        null,
        this.contextMenu2};
            this.tree1.Location = new System.Drawing.Point(12, 40);
            this.tree1.Name = "tree1";
            this.tree1.Size = new System.Drawing.Size(532, 344);
            this.tree1.TabIndex = 6;
            this.tree1.CheckedChanged += new MultiColumnTree.Tree.CheckChangedHandler(this.tree1_CheckedChanged);
            this.tree1.ColumnChanged += new MultiColumnTree.Tree.ColumnChangedHandler(this.tree1_ColumnChanged);
            this.tree1.Selected += new MultiColumnTree.Tree.SelectedHandler(this.tree1_Selected);
            // 
            // textBox1
            // 
            this.textBox1.Location = new System.Drawing.Point(14, 416);
            this.textBox1.Name = "textBox1";
            this.textBox1.Size = new System.Drawing.Size(400, 20);
            this.textBox1.TabIndex = 1;
            this.textBox1.Text = "textBox1";
            // 
            // textBox2
            // 
            this.textBox2.Location = new System.Drawing.Point(14, 440);
            this.textBox2.Name = "textBox2";
            this.textBox2.Size = new System.Drawing.Size(400, 20);
            this.textBox2.TabIndex = 2;
            this.textBox2.Text = "textBox2";
            // 
            // textBox3
            // 
            this.textBox3.Location = new System.Drawing.Point(14, 464);
            this.textBox3.Name = "textBox3";
            this.textBox3.Size = new System.Drawing.Size(400, 20);
            this.textBox3.TabIndex = 3;
            this.textBox3.Text = "textBox3";
            // 
            // label1
            // 
            this.label1.Location = new System.Drawing.Point(14, 392);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(100, 23);
            this.label1.TabIndex = 4;
            this.label1.Text = "Events";
            // 
            // label2
            // 
            this.label2.Location = new System.Drawing.Point(24, 16);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(100, 23);
            this.label2.TabIndex = 5;
            this.label2.Text = "MultiColumnTree";
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(556, 502);
            this.Controls.Add(this.label2);
            this.Controls.Add(this.label1);
            this.Controls.Add(this.textBox3);
            this.Controls.Add(this.textBox2);
            this.Controls.Add(this.textBox1);
            this.Controls.Add(this.tree1);
            this.KeyPreview = true;
            this.Name = "Form1";
            this.Text = "Form1";
            this.Load += new System.EventHandler(this.Form1_Load);
            this.ResumeLayout(false);
            this.PerformLayout();

		}
		#endregion

		/// <summary>
		/// Der Haupteinstiegspunkt fr die Anwendung.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		/// <summary>
		/// Das Verzeichnis c:\ wird gescannt und im Baum angezeigt.
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void Form1_Load(object sender, System.EventArgs e) {
			ScanDirectory(new DirectoryInfo(@"c:\windows\system32"),tree1.RootNode.Nodes);
			tree1.ShowTree();
		}

		/// <summary>
		/// Rekursiver Scann des Verzeichnisbaumes (nicht alles).
		/// Die Nodes im MCT sind vom Type MCTNode, abgeleitet vom TreeNode.
		/// In jedem MCTNode wird ein MCTSource Objekt registriert, welches die 
		/// Properties fr die Spalten zur Verfgung stellt. 
		/// Das MCTSource Objekt dient als Wrapper fr unterschiedliche Objekte. In diesem
		/// Beispiel sind es DirectoryInfo- und FileInfo Objekte.
		/// Die MCTNode Objekte halten ber TreeRowLayout die Layoutobjekte.
		/// </summary>
		/// <param name="dir">DirectoryInfo</param>
		/// <param name="nodes">TreeNodeCollection</param>
		private void ScanDirectory (DirectoryInfo dir, TreeNodeCollection nodes) {
			MCTNode n = new MCTNode(new MCTSource(dir));
			nodes.Add(n);
			int count;
			count = 5; // die ersten n Unterverzeichnisse
			DirectoryInfo[] dirs = dir.GetDirectories();
			foreach (DirectoryInfo di in dirs) {
				if (di.Name.ToCharArray()[0] >= 'a') {
					ScanDirectory(di,n.Nodes);
					if (--count == 0) break;
				}
			}
			count = 5; // die ersten n Dateien
			FileInfo[] files = dir.GetFiles();
			foreach (FileInfo fi in files) {
				if (fi.Name.ToCharArray()[0] >= 'a') {
					n.Nodes.Add(new MCTNode(new MCTSource(fi)));
					if (--count == 0) break;
				}
			}
		}

		/// <summary>
		/// ffnet eine Textbox, um den Inhalt zu bearbeiten.
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void menuItemEdit_Click(object sender, System.EventArgs e) {
			tree1.OpenTextBox();
		}

        private void tree1_Selected(object sender, MultiColumnTree.EventArgs e) {
			textBox1.Text = sender.ToString();
		}
        private void tree1_CheckedChanged(object sender, MultiColumnTree.EventArgs e) {
			textBox2.Text = e.BoolValue.ToString();
		}
        private void tree1_ColumnChanged(object sender, MultiColumnTree.EventArgs e) {
			textBox3.Text = sender.ToString();
		}
	}
}
