using System;
using System.IO;

namespace MultiColumnTree
{
	/// <summary>
	/// MCTSource ist ein Objekt, welches im Baum aus MCTNode Objekten als Source registriert wird.
	/// Es muss die Properties 'Checked', 'IsFolder', 'Hidden' und fr jede Spalte bereitstellen.  
	/// </summary>
	public class MCTSource
	{
		private Object obj;
		public MCTSource(Object di)
		{
			obj = di;
			@checked = false;
			if (obj is DirectoryInfo) 
				isFolder = true;
			else
				isFolder = false;
		}
		private bool @checked;
		public bool Checked {
			set {@checked = value;}
			get {return @checked;}
		}
		private bool isFolder;
		public bool IsFolder {
			set {isFolder = value;}
			get {return isFolder;}
		}
		private bool hidden;
		public bool Hidden {
			set {hidden = value;}
			get {return hidden;}
		}
		public string Name {
			get {
				if (obj is DirectoryInfo) return ((DirectoryInfo)obj).Name;
				if (obj is FileInfo) return ((FileInfo)obj).Name;
				return "?";
			}
		}
		private string create;
		public string Create {
			get {
				if (create == null) {
					if (obj is DirectoryInfo) return ((DirectoryInfo)obj).CreationTime.ToString();
					if (obj is FileInfo) return ((FileInfo)obj).CreationTime.ToString();
				}
				return create;
			}
			set {create = value;}
		}
		public string Write {
			get {
				if (obj is DirectoryInfo) return ((DirectoryInfo)obj).LastWriteTime.ToString();
				if (obj is FileInfo) return ((FileInfo)obj).LastWriteTime.ToString();
				return "?";
			}
		}
		public string Access {
			get {
				if (obj is DirectoryInfo) return ((DirectoryInfo)obj).LastAccessTime.ToString();
				if (obj is FileInfo) return ((FileInfo)obj).LastAccessTime.ToString();
				return "?";
			}
		}

	}

}
